#ifndef _ANALYSIS_H_
#define _ANALYSIS_H_

#include "Elements.h"
#include "Point.h"
#include "Rectangle.h"
#include "Image.h"
#include "Image8.h"
#include "Image24.h"

class Analysis {

public:
  //Analysis();
  //~Analysis();

  unsigned int getNumberOfPixels(const Image*);
  unsigned int getNumberOfBlackPixels(const Image*);
  unsigned int getNumberOfWhitePixels(const Image*);

  Point getCenterOfBlackPixels(const Image*, Rectangle, unsigned int limit = 0);
  Point getCenterOfBlackPixelsMedian(const Image*, Rectangle, unsigned int limit = 0);
  Point getCenterOfBlackPixelsIterative(const Image*, Rectangle, unsigned int repeats, unsigned int limit = 0);
  Point getCenterOfBlackPixelsGreyscale(const Image*, Rectangle, unsigned int limit = 255);
  Point getCenterOfBlackPixelsGreyscaleIterative(const Image*, Rectangle, unsigned int repeats, unsigned int limit = 255);
  unsigned int getNumberOfBlackPixels(const Image*, Rectangle);
  unsigned int getNumberOfDarkPixels(const Image*, Rectangle, unsigned int limit);

  void addDetectedPixels(const Image*, Image*, Rectangle);

private:
  
  void adaptRect2ullr (int &x1, int &y1, int &x2, int &y2, \
                       unsigned int maxWidth, unsigned int maxHeight) const;

  double dist(Point, double x, double y);

};

#endif










