#ifndef _BRAIDEDNODE_H_
#define _BRAIDEDNODE_H_


#include "Node.h"
#include "TreeNode.h"

template<class T> class BraidedSearchTree;

template<class T> class BraidedNode : public Node, public TreeNode<T> {
  public:
    BraidedNode(T);
    BraidedNode<T> *rchild();
    BraidedNode<T> *lchild();
    BraidedNode<T> *next();
    BraidedNode<T> *prev();
    friend class BraidedSearchTree<T>;
};

template<class T> BraidedNode<T>::BraidedNode(T val) : TreeNode<T>(val) { };

template<class T> BraidedNode<T> *BraidedNode<T>::rchild() {
  return (BraidedNode<T>*)_rchild;
};

template<class T> BraidedNode<T> *BraidedNode<T>::lchild() {
  return (BraidedNode<T>*)_lchild;
};

template<class T> BraidedNode<T> *BraidedNode<T>::next() {
  return (BraidedNode<T>*)_next;
};

template<class T> BraidedNode<T> *BraidedNode<T>::prev() {
  return (BraidedNode<T>*)_prev;
};

#endif // _BRAIDEDNODE_H_






