/*
 * ColorTypes.h
 *
 * Copyright (C) 1995, Christoph Streit <streit@iam.unibe.ch>
 *                     Stephan Amann <amann@iam.unibe.ch>
 *                     University of Berne, Switzerland
 *
 * All rights reserved.
 *
 * This software may be freely copied, modified, and redistributed
 * provided that this copyright notice is preserved on all copies.
 *
 * You may not distribute this software, in whole or in part, as part of
 * any commercial product without the express consent of the authors.
 *
 * There is no warranty or other guarantee of fitness of this software
 * for any purpose.  It is provided solely "as is".
 *
 * -----------------------------------------------------------------------------
 *  $Id: ColorTypes.h,v 1.3 1995/08/03 16:15:09 streit Exp $
 * -----------------------------------------------------------------------------
 */

#ifndef _ColorTypes_H
#define  _ColorTypes_H

#include "PrimitiveTypes.h"
#include "Color.h"

//__________________________________________________________________________ RGB

class RGB : public Color {
public:
  // RGB();                       // Use default version.
  // RGB(const RGB&);             // Use default version.
  // ~RGB();                      // Use default version.
  // RGB& operator=(const RGB&);  // Use default version.

  void setValue(float c1, float c2, float c3);
  void setValue(float value);
  void setValue(bool value);
  void getValue(float& c1, float& c2, float& c3) const;
  void getValue(float& value) const;
  void getValue(bool& value) const;
};

//_________________________________________________________________________ Grey

class Grey {
public:
  Grey();
  // Grey(const Grey&);             // Use default version.
  // ~Grey();                       // Use default version.
  // Grey& operator=(const Grey&);  // Use default version.

  void setValue(float c1, float c2, float c3);
  void setValue(float value);
  void setValue(bool value);
  void getValue(float& c1, float& c2, float& c3) const;
  void getValue(float& value) const;
  void getValue(bool& value) const;

private:
  float myValue;
};

inline Grey::Grey()
: myValue(0.0)
{}

//___________________________________________________________________________ BW

class BW {
public:
  BW();
  // BW(const BW&);             // Use default version.
  // ~BW();                     // Use default version.
  // BW& operator=(const BW&);  // Use default version.

  void setValue(float c1, float c2, float c3);
  void setValue(float value);
  void setValue(bool value);
  void getValue(float& c1, float& c2, float& c3) const;
  void getValue(float& value) const;
  void getValue(bool& value) const;

private:
  bool myValue;
};

inline BW::BW()
: myValue(false)
{}

#endif // _ColorTypes_H
