#ifndef _CONVEXHULL_H_
#define _CONVEXHULL_H_

#include "Point2D.h"
#include "Polygon.h"
#include "Vertex.h"


class ConvexHull {
  public:
    ConvexHull();
    ~ConvexHull();

    Polygon *giftwrapHull(Point2D s[], const int n);
    Polygon *mergeHull(Point2D pts[], const int n);
    Polygon *insertionHull(Point2D s[], const int n);

  protected:
    enum { UPPER, LOWER };
    void swap(Point2D &a, Point2D &b);
    Polygon *mHull(Point2D *p[], int n);
    Polygon *merge(Polygon *L, Polygon *R);
    void bridge(Polygon *L, Polygon *R, Vertex* &vl, Vertex* &vr, int type);
    void supportingLine(Point2D &s, Polygon *p, int side);
    Vertex* leastVertex(Polygon &p, int (*cmp)(Point2D*,Point2D*));
    int polarCmp(Point2D *p, Point2D *q, Point2D *o);
};

#endif  // _CONVEXHULL_H
