#ifndef _DELAUNAYTRIANGULATION_H_
#define _DELAUNAYTRIANGULATION_H_

#include "Polygon.h"
#include "Point2D.h"
#include "Edge.h"
#include "Dictionary.h"
#include "List.h"


class DelaunayTriangulation {
  public:
    DelaunayTriangulation();
    ~DelaunayTriangulation();

    List<Polygon*> *apply(Point2D s[], int n);

  protected:
    // int edgeCmp(Edge *a, Edge *b);
    void updateFrontier(Dictionary<Edge*> &frontier, Point2D &a, Point2D &b);
    Edge *hullEdge(Point2D s[], int n);
    Polygon *triangle(Point2D &a, Point2D &b, Point2D &c);
    bool mate(Edge &e, Point2D s[], int n, Point2D &p);    

};

#endif  // _DELAUNAYTRIANGULATION_H_
