#include "DetectorMedian.h"
#include <math.h>

// Use STL
#include <list.h>


DetectorMedian::DetectorMedian(const Rectangle tmpRect, const unsigned int tmpThreshold = 0) {
  myThreshold = tmpThreshold;
  myRectangle = tmpRect;
};


Point DetectorMedian::apply(const Image* source, const Rectangle window) {

  Point result;
  list<unsigned int> x_werte(0);
  list<unsigned int> y_werte(0); 
  unsigned int anzPunkte = 0;
  for (int x = myRectangle.x1; x < myRectangle.x2; x++) {
    if ((x >= window.x1) && (x <= window.x2)) {
      for (int y = myRectangle.y1; y < myRectangle.y2; y++) {
        if ((y >= window.y1) && (y <= window.y2)) {
          if (source->getGreyscale(x,y) <= myThreshold) {
            #ifdef DEBUG
            cout << "[DetectorMedian::apply] ";
            cout << "Pixel: (" << x << "/" << y << ") -> ";
            cout << (int) source->getGreyscale(x,y) << endl; 
            #endif
            x_werte.push_back(x);
            y_werte.push_back(y);
            anzPunkte++;
          };
	};
      };
    };
  };

  if ((x_werte.size() > 0) && (y_werte.size() > 0)) {
    x_werte.sort();
    list<unsigned int>::iterator Ix = x_werte.begin();
    advance(Ix, x_werte.size()/2);
    result.x = *Ix;

    y_werte.sort();
    list<unsigned int>::iterator Iy = y_werte.begin();
    advance(Iy, y_werte.size()/2);
    result.y = *Iy;
  };

  cout << "[DetectorMedian::apply] Median: (" << result.x << "/" << result.y << ")" << endl;

  return result;
  
};

