#include "DetectorSimple.h"
#include <math.h>
#include <iostream.h>



DetectorSimple::DetectorSimple(const Rectangle tmpRect, const unsigned int tmpThreshold = 0) {
  myThreshold = tmpThreshold;
  myRectangle = tmpRect;
};


Point DetectorSimple::apply(const Image* source, const Rectangle window) {

  Point result;
  unsigned int sum_x = 0;
  unsigned int sum_y = 0;
  unsigned int sum_p = 0;
  for (int x = myRectangle.x1; x < myRectangle.x2; x++) {
    if ((x >= window.x1) && (x <= window.x2)) {
      for (int y = myRectangle.y1; y < myRectangle.y2; y++) {
        if ((y >= window.y1) && (y <= window.y2)) {
          if (source->getGreyscale(x,y) <= myThreshold) {
            #ifdef DEBUG
            cout << "[DetectorSimple::apply] ";
            cout << "Pixel: (" << x << "/" << y << ") -> ";
            cout << (int) source->getGreyscale(x,y) << endl; 
            #endif
            sum_x += x;
            sum_y += y;
            sum_p++;
          };
	};
      };
    };
  };

  if (sum_p == 0) {
    result.x = result.y = -1;
  } else {
    result.x = (int) ((double)sum_x / (double)sum_p + 0.5);
    result.y = (int) ((double)sum_y / (double)sum_p + 0.5);
  };

  cout << "[DetectorSimple::apply] Simple center: (" << result.x << "/" << result.y << ")" << endl;

  return result;
  
};

