#ifndef _DRAWING_H_
#define _DRAWING_H_

#include "Point.h"
#include "Rectangle.h"
#include "Image.h"
#include "Elements.h"
#include <stdlib.h>


class Drawing {

public:
  Drawing() {};
  ~Drawing() {};

  void line(Image*, const Point, const Point, const Color, const Image* = NULL) const;
  void rectangle(Image*, const Rectangle, const Color) const;
  void cross(Image*, const Point, const Color, const unsigned int size = 1) const;
  void point(Image*, const Point, const Color, const Image* = NULL) const;

private:
  Drawing(Drawing&);   // no copy-constructor
  void swap(int&, int&) const;

};

#endif   // _DRAWING_H_





