#ifndef _EDGE_H_
#define _EDGE_H_

#include "Point2D.h"

class Edge {
  public:
    enum { COLLINEAR, PARALLEL, SKEW, SKEW_CROSS, SKEW_NO_CROSS };
    Point2D org;
    Point2D dest;
    Edge(Point2D &_org, Point2D &_dest);
    Edge();
    Edge &rot();
    Edge &flip();
    Point2D point(double);
    int intersect(Edge&, double&);
    int cross(Edge&, double&);
    bool isVertical();
    double slope();
    double y(double);
};

#endif // _EDGE_H_
