#include "FilterBinarize.h"
#include "Image8.h"


FilterBinarize::FilterBinarize() {
  myThreshold = 128;
};


FilterBinarize::~FilterBinarize() { };


Image* FilterBinarize::apply(const Image* source) {

  Image8* result = new Image8(source->getWidth(), source->getHeight());

  for(int y = 0; y < (int) source->getHeight(); y++) {
    for(int x = 0; x < (int) source->getWidth(); x++) {
      if (source->getGreyscale(x,y) >= myThreshold) {
        result->setGreyscale(x,y,255);
      } else {
        result->setGreyscale(x,y,0);
      };
    };
  };

  return result;

};


FilterBinarize::FilterBinarize(unsigned int threshold) {
  myThreshold = threshold;
};


void FilterBinarize::setParameters(unsigned int threshold) {
  myThreshold = threshold;
};


void FilterBinarize::getParameters(unsigned int &threshold) {
  threshold = myThreshold;
};


