#include "FilterCutMask.h"
#include <iostream.h>
#include "Image8.h"
#include "Image24.h"



FilterCutMask::FilterCutMask() { 
  myMask = NULL;
};


Image* FilterCutMask::apply(const Image* source) {

  if (myMask == NULL) {
    return NULL;
  };

  Image *result;

  switch (source->getPlanes()) {
  case 3:
    result = new Image24(source->getWidth(), source->getHeight());
    // bewegen ueber Bild
    for(unsigned int y = 0; y < source->getHeight(); y++) {
      for(unsigned int x = 0; x < source->getWidth(); x++) {
        if (myMask->getGreyscale(x,y) == 0) {
          result->setColor(x,y,source->getColor(x,y));
	} else {
          result->setColor(x,y,Color(255,255,255));
	};
      };
    };
    break;

  case 1:
    result = new Image8(source->getWidth(), source->getHeight());
    // bewegen ueber Bild
    for(unsigned int y = 0; y < source->getHeight(); y++) {
      for(unsigned int x = 0; x < source->getWidth(); x++) {
        if (myMask->getGreyscale(x,y) == 0) {
          result->setGreyscale(x,y,source->getGreyscale(x,y));
	} else {
          result->setGreyscale(x,y,255);
	};
      };
    };
    break;

  default:
    cerr << "[FilterCutMask::apply] " << source->getPlanes();
    cerr << " planes are not supported." << endl;
    cerr.flush();
    return NULL;
  };

  return result;

};


FilterCutMask::FilterCutMask(const Image* mask) {
  myMask = (Image*) mask;
};


void FilterCutMask::setParameters(const Image* mask) {
  myMask = (Image*) mask;
};


void FilterCutMask::getParameters(Image* mask) {
  mask = myMask;
};




