#include "FilterCutRectangle.h"
#include <iostream.h>
#include "Image8.h"
#include "Image24.h"



FilterCutRectangle::FilterCutRectangle() { };


FilterCutRectangle::~FilterCutRectangle() { };


Image* FilterCutRectangle::apply(const Image* source) {

  Image* result;

  unsigned int xx, yy;
  switch (source->getPlanes()) {
  case 3:
    result = new Image24(myRect.getWidth(), myRect.getHeight());
    // bewegen ueber Bild
    xx = yy = 0;
    for(int y = myRect.y1; y <= myRect.y2; y++) {
      xx = 0;
      for(int x = myRect.x1; x <= myRect.x2; x++) {
        result->setColor(xx,yy,source->getColor(x,y));
        xx++;
      };
      yy++;
    };
    break;
  case 1:
    result = new Image8(myRect.getWidth(), myRect.getHeight());
    // bewegen ueber Bild
    xx = yy = 0;
    for(int y = myRect.y1; y <= myRect.y2; y++) {
      xx = 0;
      for(int x = myRect.x1; x <= myRect.x2; x++) {
        result->setGreyscale(xx,yy,source->getGreyscale(x,y));
        xx++;
      };
      yy++;
    };
    break;
  default:
    cerr << "[FilterCutRectangle::apply] " << source->getPlanes();
    cerr << " planes are not supported." << endl;
    cerr.flush();
    return NULL;
  };

  return result;

};


FilterCutRectangle::FilterCutRectangle(Rectangle tmpRect) {
  myRect = tmpRect;
};


void FilterCutRectangle::setParameters(Rectangle tmpRect) {
  myRect = tmpRect;
};


void FilterCutRectangle::getParameters(Rectangle &tmpRect) {
  tmpRect = myRect;
};

