#include "FilterExpandBlack.h"
#include <iostream.h>
#include "Histogram.h"
#include "Image8.h"


FilterExpandBlack::FilterExpandBlack() { 
  myCount = 0;
};


Image* FilterExpandBlack::apply(const Image* source) {

  if (myRectangle.valid() == false) {
    return NULL;
  }; 

  // Otsu in Fenster berechnen
  Histogram myHistogram;
  myHistogram.generate(source, myRectangle);
  unsigned int otsu = myHistogram.votsu();
  Image8* result = new Image8(source->getWidth(), source->getHeight());
  result->setWhite();

  // Fensterbereich S/W wandeln und in Ziel kopieren
  for (int x = myRectangle.x1; x < myRectangle.x2; x++) {
    for (int y = myRectangle.y1; y < myRectangle.y2; y++) {
      if (source->getGreyscale(x,y) <= otsu) {
        result->setGreyscale(x,y,0);
      };
    };
  };

  // Fensterbereich verdicken    
  Image* input = source->copy();
  Image* output = result->copy();
  for (unsigned int i = 1; i <= myCount; i++) {
    
    // Bildausschnitt verarbeiten
    for (int x = myRectangle.x1; x < myRectangle.x2; x++) {
      for (int y = myRectangle.y1; y < myRectangle.y2; y++) {

        unsigned int summe = 0;
        for (int xx = x - 1; xx <= x + 1; xx++) {
          for (int yy = y - 1; yy <= y + 1; yy++) {
            if (input->getGreyscale(xx,yy) == 0) {
              summe++;
	    };
	  };
	};
 
        if (summe > 0) {
          output->setGreyscale(x,y,0);
	};

      };
    };
    
    // Quelle lschen, Ziel wird neue Quelle
    delete input;
    input = output->copy();

  };

  delete input;
  result->adoptImage8(output->getImage8());
  delete output;

  return result;

};


FilterExpandBlack::FilterExpandBlack(unsigned int count, Rectangle rect) {
  myCount = count;
  myRectangle = rect;
};


void FilterExpandBlack::setParameters(unsigned int count, Rectangle rect) {
  myCount = count;
  myRectangle = rect;
};


void FilterExpandBlack::getParameters(unsigned int &count, Rectangle &rect) {
  count = myCount;
  rect = myRectangle;
};







