#include "FilterExpandGreyscale.h"
#include "Image8.h"


FilterExpandGreyscale::FilterExpandGreyscale() { 
};


FilterExpandGreyscale::FilterExpandGreyscale(Rectangle bounds) { 
  myBounds = bounds;
};


FilterExpandGreyscale::~FilterExpandGreyscale() { };


void FilterExpandGreyscale::setParameters(Rectangle bounds) {
  myBounds = bounds;
};


void FilterExpandGreyscale::getParameters(Rectangle &bounds) {
  bounds = myBounds;
};


Image* FilterExpandGreyscale::apply(const Image* source) {

  Image8* result = new Image8(source->getWidth(), source->getHeight());

  unsigned int darkest = 0;
  unsigned int sum = 0;
  unsigned int grey;

  for (int x = myBounds.x1; x <= myBounds.x2; x++) {
    for (int y = myBounds.y1; y <= myBounds.y2; y++) {

        sum = 0;
        darkest = 255;

        for (int xx = x-1; xx <= x+1; xx++) {
          for (int yy = y-1; yy <= y+1; yy++) {

            unsigned int grey = source->getGreyscale(xx,yy);
            sum += grey;
            if (grey < darkest) {
              darkest = grey;
            };

          };
        };

        // grey = (sum / 9.0);        
        // grey = darkest;
        grey = (unsigned int) ( ((sum/9.0) + (double) darkest) / 2.0);

        result->setGreyscale(x,y, (byte) grey);

    }; // for y
  }; // for x

  return result;

};








