#include "FilterRotate180.h"
#include <iostream.h>
#include "Image8.h"
#include "Image24.h"


FilterRotate180::FilterRotate180() { };


FilterRotate180::~FilterRotate180() { };


Image* FilterRotate180::apply(const Image* source) {

  Image *result;

  int myWidth = source->getWidth();
  int myHeight = source->getHeight();

  switch (source->getPlanes()) {
  case 3:
    result = new Image24(myWidth, myHeight);
    // bewegen ueber Bild
    for(int y = 0; y < myHeight; y++) {
      for(int x = 0; x < myWidth; x++) {
        result->setColor(x,y,source->getColor(myWidth-x,myHeight-y));
      };
    };
    break;
  case 1:
    result = new Image8(myWidth, myHeight);
    // bewegen ueber Bild
    for(int y = 0; y < myHeight; y++) {
      for(int x = 0; x < myWidth; x++) {
        result->setGreyscale(x,y,source->getGreyscale(myWidth-x,myHeight-y));
      };
    };
    break;
  default:
    cerr << "[FilterRotate180::apply] " << source->getPlanes();
    cerr << " planes are not supported." << endl;
    cerr.flush();
    return NULL;
  };

  return result;

};



