#include "FilterScale.h"
#include "Image8.h"
#include "Image24.h"
#include <iostream.h>


FilterScale::FilterScale() { 
  myScale = 1.0;
};


FilterScale::~FilterScale() { };


Image* FilterScale::apply(const Image* source) {

  Image* result;

  int newWidth = (int) ( (float) source->getWidth() * myScale);
  int newHeight = (int) ( (float) source->getHeight() * myScale);

  switch (source->getPlanes()) {
  case 3:
    result = new Image24(newWidth, newHeight);
    // bewegen ueber Bild
    for(int y = 0; y < newHeight; y++) {
      for(int x = 0; x < newWidth; x++) {
        result->setColor(x,y,source->getColor((int) ((float)x/myScale), \
                                              (int) ((float)y/myScale)));
      };
    };
    break;
  case 1:
    result = new Image8(newWidth, newHeight);
    // bewegen ueber Bild
    for(int y = 0; y < newHeight; y++) {
      for(int x = 0; x < newWidth; x++) {
        result->setGreyscale(x,y,source->getGreyscale((int) ((float)x/myScale), \
                                                      (int) ((float)y/myScale)));
      };
    };
    break;
  default:
    cerr << "[FilterScale::apply] " << source->getPlanes();
    cerr << " planes are not supported." << endl;
    cerr.flush();
    return NULL;
  };

  return result;

};

  
FilterScale::FilterScale(float scale) {
  myScale = scale;
};
 

void FilterScale::setParameters(float scale) {
  myScale = scale;
};
  

void FilterScale::getParameters(float &scale) {
  scale = myScale;
};

