#ifndef _HISTOGRAM_H_
#define _HISTOGRAM_H_

#include "Elements.h"
#include "Point.h"
#include "Rectangle.h"
#include "spider.h"

class Image;


class Histogram {

public:
  Histogram();
  Histogram(const Histogram&);        // Copy Konstruktor
  Histogram(const Image*);
  ~Histogram();

  void print() const;
  void generate(const Image*);
  void generate(const Image*, Rectangle);
  unsigned long getValueCount(const byte) const;
  double getValuePercent(const byte) const;
  unsigned long getPixelcount() const;
  unsigned int getMaxValue() const;
  unsigned int getMinValue() const;
  unsigned long getMinCount() const;
  unsigned long getMaxCount() const;

  double *getHistogramPercent();
  unsigned long *getHistogramCount();

  Image* createImage() const;

  int otsu() const;
  int otsudetails(float &rmean, float &vari, float &p0, float &p1, \
                  float &a0, float &a1, float &sep) const;
  unsigned int votsu() const;
  unsigned int darkPixels(unsigned int) const;
  unsigned int getDelta() const;
  void eliminateWhitePixels();

  Histogram& operator=(const Histogram&);

private:
  void adaptRect2ullr (int &x1, int &y1, int &x2, int &y2, \
                       unsigned int maxWidth, unsigned int maxHeight) const;

protected:
  double myHistPercent[256];
  unsigned long myHistCount[256];
  unsigned long myPixels;
  unsigned int myMaxValue, myMinValue;
  unsigned long myMaxCount, myMinCount;
};

#endif   // _HISTOGRAM_H_





