#include "Image.h"
#include <fstream.h>
#include <time.h>

// int Image::theID;

void Image::writeDebugInformation(char *tmpClass, char *tmpMethod, char *tmpType, int tmpPointer) {

  ofstream deb;
  deb.open("memdebug.txt", ios::app);

  // create timestamp
  time_t seconds;
  seconds = time(&seconds);
  tm* currentTime;
  currentTime = localtime(&seconds);
 
//  deb << "19" << currentTime->tm_year << "-" << (currentTime->tm_mon + 1) << "-" << currentTime->tm_mday << " ";
//  deb << currentTime->tm_hour << ":" << currentTime->tm_min << ":" << currentTime->tm_sec << "|";
  deb << tmpClass << "|" << tmpMethod << "|" << tmpType << "|" << tmpPointer << endl;
  deb.close();

};


Image::Image () {
  #ifdef DEBUG
  cout << "Image::Image() called" << endl;
  cout.flush();
  #endif

  //writeDebugInformation("Image", "Image()", "+", id);

  //theID++;
  //id = theID;

  myPlanes = 0;
  myWidth = 0;
  myHeight = 0;
  myImage = NULL;
};


Image::~Image () {
  #ifdef DEBUG
  cout << "Image::~Image() called ... nothing done in here" << endl;
  cout.flush();
  #endif

  //writeDebugInformation("Image", "~Image()", "-", id);

  //delete[] myImage;

};


void Image::setWhite() {
  for (unsigned int i = 0; i < myPlanes*myWidth*myHeight; i++) {
    myImage[i] = 255;
  };
};


void Image::setBlack() {
  for (unsigned int i = 0; i < myPlanes*myWidth*myHeight; i++) {
    myImage[i] = 0;
  };
};


inline unsigned int Image::getWidth () const {
  return myWidth;
};


inline unsigned int Image::getHeight () const {
  return myHeight;
};


inline unsigned int Image::getPlanes () const {
  return myPlanes;
};


inline unsigned int Image::checkX(int x) const {

  // x weiter links als linker Rand
  if (x < 0) { return 0; };

  // x weiter rechts als rechter Rand
  if (x >= (int) myWidth) { return myWidth - 1; };
  
  return x;

};


inline unsigned int Image::checkY(int y) const {

  // y weiter oben als oberer Rand
  if (y < 0) { return 0; };

  // y weiter unten als unterer Rand
  if (y >= (int) myHeight) { return myHeight - 1; };

  return y;

};











