#ifndef _IMAGE_H_
#define _IMAGE_H_

#include "Elements.h"


class Image8;
class Image24;

class Image {

public:
  Image();
  // Image(const Image&);        // Copy Konstruktor
  // Image(unsigned int size_x, unsigned int size_y);
  virtual ~Image();
  virtual Image* copy() const = 0;

  virtual inline Color getColor(int x, int y) const = 0;
  virtual inline byte getGreyscale(int x, int y) const = 0;
  virtual inline void setColor(unsigned int x, unsigned int y, Color) = 0;
  virtual inline void setGreyscale(unsigned int x, unsigned int y, byte) = 0;

  void setWhite();
  void setBlack();

  virtual void adoptImage8(byte*) = 0;
  virtual void adoptImage24(byte*) = 0;
  virtual byte* getImage8() const = 0;
  virtual byte* getImage24() const = 0;
  virtual byte* getImage() const = 0;

  // virtual Image operator-(const Image&) const = 0;
  // virtual Image operator+(const Image&) const = 0;
  virtual Image& operator=(const Image&) = 0;
  
  inline unsigned int getWidth() const;
  inline unsigned int getHeight() const;
  inline unsigned int getPlanes() const;

  //int id;

protected:

  //static int theID = 0;
  byte *myImage;
  unsigned int myHeight, myWidth;
  unsigned int myPlanes;

  inline unsigned int checkX(int) const;
  inline unsigned int checkY(int) const;

  void writeDebugInformation(char *tmpClass, char *tmpMethod, char *tmpType, int tmpPointer);

};

#endif   // _IMAGE_H_









