#ifndef _IMAGE24_H_
#define _IMAGE24_H_

#include "Image.h"


class Image24 : public Image {

public:
  Image24();
  Image24(const Image&);
  Image24(unsigned int size_x, unsigned int size_y);
  ~Image24();
  Image* copy() const;

  inline Color getColor(int x, int y) const;
  inline byte getGreyscale(int x, int y) const;
  inline void setColor(unsigned int x, unsigned int y, Color);
  inline void setGreyscale(unsigned int x, unsigned int y, byte);

  // void setWhite();           // derived from Image
  // void setBlack();           // derived from Image

  void adoptImage8(byte*); 
  void adoptImage24(byte*);
  byte* getImage8() const;  
  byte* getImage24() const; 
  byte* getImage() const;       // returns internal representation

  Image24 operator-(const Image24&) const;
  Image24 operator+(const Image24&) const;
  Image& operator=(const Image&);

  // inline unsigned int getWidth() const;
  // inline unsigned int getHeight() const;
  // inline unsigned int getPlanes() const;


protected:      // everything derived from Image
  // byte *myImage;
  // unsigned int myHeight, myWidth;
  // unsigned int myPlanes;

  // inline unsigned int checkX(int) const;
  // inline unsigned int checkY(int) const;

};

#endif   // _IMAGE24_H_



