#ifndef _IMAGESOURCE_H_
#define _IMAGESOURCE_H_

#include "Elements.h"
#include "Image.h"

class ImageSource {

// Unerwuenschte Methoden ausschliessen
private:
  ImageSource(const ImageSource&);

public:
  ImageSource();
  // ~ImageSource();

  virtual Image* getNextImage(int step = 1) = 0;
  unsigned int getFirstIndex();
  unsigned int getLastIndex();
  virtual void setPosition(unsigned int) = 0;
  virtual unsigned int getPosition() = 0;
  virtual Image* getImageAbsolute(unsigned int) = 0;
  virtual Image* getImageRelative(int = 0) = 0;
  virtual void movePosition(int = 1) = 0;
  unsigned int getImageHeight();
  unsigned int getImageWidth();

protected:
  unsigned int actualImageNumber; 
  unsigned int firstImageNumber;
  unsigned int lastImageNumber;
  unsigned int myWidth;
  unsigned int myHeight;

};

#endif   // _IMAGESOURCE_H_

