#ifndef _INTERPOLATOR_H_
#define _INTERPOLATOR_H_

#include "Point.h"
#include <vector.h>
#include "Image.h"


class Interpolator {

public:
  Interpolator() {};
  ~Interpolator() {};

  Interpolator(const unsigned int maxInterpolate, \
               const unsigned int maxDistance, \
               const unsigned int maxGaps);

  vector<Point> apply(const vector<Point>) const;

  void setParameters(const unsigned int maxInterpolate, \
                     const unsigned int maxDistance, \
                     const unsigned int maxGaps);

  void setMaskImage(const Image*);

  void setVerboseMode(const int);

private:
  Interpolator(Interpolator&);

  inline double dist(const Point, const Point) const;

  unsigned int myMaxGaps;
  unsigned int myMaxDistance;
  unsigned int myMaxInterpolate;

  int myVerboseMode;

  Image* myMaskImage;

};

#endif   // _INTERPOLATOR_H_





