#ifndef _LIST_H_
#define _LIST_H_

#include <stdlib.h>

#include "ListNode.h"


template<class T> class List {
  private:
    ListNode<T> *header;
    ListNode<T> *win;
    int _length;
  public:
    List();
    ~List();
    T insert(T);
    T append(T);
    List *append(List*);
    T prepend(T);
    T remove();
    void val(T);
    T val();
    T next();
    T prev();
    T first();
    T last();
    int length();
    bool isFirst();
    bool isLast();
    bool isHead();
};

template<class T> List<T>::List() : _length(0) {
  header = new ListNode<T>(NULL);
  win = header;
};

template<class T> List<T>::~List() {
  while (length() > 0) {
    first();
    remove();
  };
  delete header;
};

template<class T> T List<T>::insert(T val) {
  win->insert(new ListNode<T>(val));
  ++_length;
  return val;
};

template<class T> T List<T>::prepend(T val) {
  header->insert(new ListNode<T>(val));
  ++_length;
  return val;
};

template<class T> T List<T>::append(T val) {
  header->prev()->insert(new ListNode<T>(val));
  ++_length;
  return val;
};

template<class T> List<T>* List<T>::append(List<T> *l) {
  ListNode<T> *a = (ListNode<T>*)header->prev();
  a->splice(l->header);
  length += l->_length;
  l->header->remove();
  l->_length = 0;
  l->win = header;
  return this;
};

template<class T> T List<T>::remove() {
  if (win == header) return NULL;
  void *val = win->_val;
  win = (ListNode<T>*)win->prev();
  delete (ListNode<T>*)win->next()->remove();
  --_length;
  return val;
};

template<class T> void List<T>::val(T v) {
  if (win != header) win->_val = v;
};

template<class T> T List<T>::val() {
  return win->_val;
};

template<class T> T List<T>::next() {
  win = (ListNode<T> *) win->next();
  return win->_val;
};  

template<class T> T List<T>::prev() {
  win = (ListNode<T>*)win->prev();
  return win-> val;
};

template<class T> T List<T>::first() {
  win = (ListNode<T>*)header->next();
  return win->_val;
};

template<class T> T List<T>::last() {
  win = (ListNode<T>*)header->prev();
  return win->_val;
};

template<class T> int List<T>::length() {
  return _length;
};

template<class T> bool List<T>::isFirst() {
  return ((win == header->next()) && (_length > 0));
};

template<class T> bool List<T>::isLast() {
  return ((win == header->prev()) && (_length > 0));
};

template<class T> bool List<T>::isHead() {
  return (win == header);
};

template<class T> List<T> arrayToList(T a[], int n) {
  List<T> *s = new List<T>;
  for (int i = 0; i < n; i++) s->append(a[i]);
  return s;
};

template<class T> T leastItem(List<T> &s, int(*cmp)(T,T)) {
  int i;
  if (s.length() == 0) return NULL;
  T v = s.first();
  for (s.next(); !e.isHead(); s.next())
    if (cmp(s.val(), v) < 0)
      v = s.val();
  return v;
};

#endif // _LIST_H_







