/*
 * MPixmapExemplar.h
 *
 * Copyright (C) 1995, Stephan Amann <amann@iam.unibe.ch>
 *                     Christoph Streit <streit@iam.unibe.ch>
 *                     University of Berne, Switzerland
 *
 * All rights reserved.
 *
 * This software may be freely copied, modified, and redistributed
 * provided that this copyright notice is preserved on all copies.
 *
 * You may not distribute this software, in whole or in part, as part of
 * any commercial product without the express consent of the authors.
 *
 * There is no warranty or other guarantee of fitness of this software
 * for any purpose.  It is provided solely "as is".
 *
 * -----------------------------------------------------------------------------
 *  $Id: MPixmapExemplar.h,v 1.1 1995/08/14 09:02:44 amann Exp $
 * -----------------------------------------------------------------------------
 */

#ifndef _MPixmapExemplar_H
# define _MPixmapExemplar_H

#include "AbstractPixmap.h"

//_____________________________________________________________  MPixmapExemplar

class MPixmapExemplar {
public:
  MPixmapExemplar();
  virtual ~MPixmapExemplar();

  void adoptPixmapExemplar(AbstractPixmap* pm);
  void setResolution(int resX, int resY);
  
protected: 
  AbstractPixmap* createPixmap() const;
  AbstractPixmap* createPixmap(int resX, int resY) const;

private:
  AbstractPixmap* myPixmapExemplar;
  int myResX, myResY;
  
private:
  MPixmapExemplar(const MPixmapExemplar&);	           // No copies.
  MPixmapExemplar& operator=(const MPixmapExemplar&); // No assignments.
};

inline void MPixmapExemplar::setResolution(int resX, int resY)
{
  myResX = resX;
  myResY = resY;
}

#endif // _MPixmapExemplar_H
