#ifndef _MERGESORT_H_
#define _MERGESORT_H_

template<class T>
void mergeSort(T a[], int n, int (*cmp)(T,T)) {
  mSort(a, 0, n-1, cmp);
};

template<class T>
void mSort(T a[], int l, int r, int (*cmp)(T,T)) {
  if (l < r) {
    int m = (l + r) / 2;
    mSort(a, l, m, cmp);
    mSort(a, m+1, r, cmp);
    merge(a, l, m, r, cmp);
  };
};

template<class T>
void merge(T x[], int l, int m, int r, int (*cmp)(T,T)) {
  T *a = x+l;
  T *b = x+m+1;
  T *c = new T[r-l+1];
  int aindx = 0, bindx = 0, cindx = 0;
  int alim = m-l+1, blim = r-m;
  while((aindx < alim) && (bindx < blim))
    if ((*cmp)(a[aindx], b[bindx]) < 0)
      c[cindx++] = a[aindx++];
    else
      c[cindx++] = b[bindx++];
  while(aindx < alim)           // copy rest of a
    c[cindx++] = a[aindx++];
  while(bindx < blim)           // copy rest of b
    c[cindx++] = b[bindx++];
  for (aindx=cindx=0; aindx <= r-l; a[aindx++] = c[cindx++])
    ; // copy back
  delete c;
};

#endif  // _MERGESORT_H
