#include "PPMReader.h"
#include <fstream.h>
#include <iostream.h>


Image* PPMReader::apply(const char* infile) const {

  ifstream eingabe(infile, ios::bin | ios::in);
  if (!eingabe) {
    cout << "Fehler beim Oeffnen der Datei: " << infile << " !" << endl;
  };

  // Magic Number
  char magic[3];
  eingabe.read(magic,3);
  
  // Kommentarzeile
  unsigned char kommentar;
  kommentar = eingabe.peek();
  if (kommentar == '#') {
    while (kommentar != 10) {
      eingabe.get(kommentar);
    };
  };

  // Auflsung x, y
  int max_x, max_y;
  eingabe >> max_x >> max_y;

  Image *result;

  switch (magic[1]) {
  case '6':
    result = new Image24(max_x, max_y);
    break;

  case '5':
    result = new Image8(max_x, max_y);
    break;

  default:
    cerr << "[PPMReader::apply] The PPM magic number " << magic;
    cerr << " is not supported" << endl;
    cerr.flush();
    exit(0);
  };

  // Image result(max_x, max_y);

  byte *myImage;
  myImage = new byte[result->getWidth()*result->getHeight()\
                     *result->getPlanes()];

  // Farbtiefe
  char farbtiefe[100];
  eingabe.getline(farbtiefe, 2);    // newline ignorieren
  eingabe.getline(farbtiefe, 100);

  eingabe.read(myImage, result->getWidth()*result->getHeight()*\
                        result->getPlanes()*sizeof(byte));

  eingabe.close();

  switch (result->getPlanes()) {
  case 1:
    result->adoptImage8(myImage);  
    break;
  case 3:
  default:
    result->adoptImage24(myImage);
  };

  return result;

};





