#include "PPMWriter.h"
#include <fstream.h>
#include <iostream.h>
#include <string.h>

PPMWriter::PPMWriter(const char* outfile) {
  strcpy(filename, outfile);
};

PPMWriter::PPMWriter() {
  strcpy(filename, "");
};
  
void PPMWriter::setFilename(const char* outfile) {
  strcpy(filename, outfile);
};

void PPMWriter::apply(const Image* bild) {
  
  ofstream ausgabe(filename, ios::bin | ios::out);
  if (!ausgabe) {
    cout << "Fehler beim Schreiben der Datei: " << filename << " !" << endl;
  };

  // Magic Number
  switch (bild->getPlanes()) {
  case 1:
    ausgabe << "P5" << endl;      
    break;
  case 3:
    ausgabe << "P6" << endl;
    break;
  default:
    cerr << "[PPMWriter::apply] An Image with " << bild->getPlanes();
    cerr << " is not supported" << endl;
    cerr.flush();
    exit(0);
  };
  
  // Kommentarzeile
  ausgabe << "# CREATOR: PPMWriter::apply" << endl;

  // Aufloesung x, y
  ausgabe << bild->getWidth() << " " << bild->getHeight() <<endl;

  // Farbtiefe
  ausgabe << "255" << endl;

  byte* pixmap;
  pixmap = bild->getImage();
  ausgabe.write(pixmap, bild->getPlanes()*bild->getWidth()*\
                bild->getHeight()*sizeof(byte)); 
  ausgabe.close();
  delete[] pixmap;

};









