#include "Point.h"
#include <math.h>


Point::Point() {
  x = y = -1;
};


Point::Point(unsigned int _x, unsigned int _y) {
  x = _x;
  y = _y;
};


Point::Point(const Point& desc) {
  x = desc.x;
  y = desc.y;
};


Point& Point::operator=(const Point& rhs) {
  if (this == &rhs) { 
    return *this;
  };
  x = rhs.x;
  y = rhs.y;
  return *this;
};


int Point::operator==(const Point& rhs) {
  return ((x == rhs.x) && (y == rhs.y));
};


int Point::valid() const {
  return ((x >= 0) && (y >= 0));
};

Point operator*(const double s, const Point &p) {
  return Point((unsigned int)(s*p.x), (unsigned int)(s*p.y));
};

ostream& operator<<(ostream& os, const Point &p) {
  if (p.valid()) {
    os << "(" << p.x << "/" << p.y << ")";
  } else {
    os << "NP";
  };
  return os;
};

double Point::dist(const Point p) const {

  return sqrt( (x-p.x)*(x-p.x) + (y-p.y)*(y-p.y) );

};


