#ifndef _POINT2D_H_
#define _POINT2D_H_

class Edge;

class Point2D {
  public:
    enum { LEFT, RIGHT, BEYOND, BEHIND, BETWEEN, ORIGIN, DESTINATION };
    double x, y;
    Point2D(double _x = 0.0, double _y = 0.0);
    Point2D operator+(const Point2D&);
    Point2D operator-(const Point2D&);
    friend Point2D operator*(const double, const Point2D&);
    double operator[](int);
    int operator==(const Point2D&);
    int operator!=(const Point2D&);
    int operator<(const Point2D&);
    int operator>(const Point2D&);
    int classify(Point2D&, Point2D&);
    int classify(Edge&);
    double polarAngle();
    double length();
    double distance(Edge&);
};


#endif // _POINT2D_H_
