#ifndef _POLYGON_H_
#define _POLYGON_H_

#include "Vertex.h"
#include "Point2D.h"
#include "Edge.h"


class Polygon {
  private:
    Vertex *_v;
    int _size;
    void resize();
  public:
    Polygon();
    Polygon(Polygon&);
    Polygon(Vertex*);
    ~Polygon();
    Vertex *v();
    int size();
    Point2D point();
    Edge edge();
    Vertex *cw();
    Vertex *ccw();
    Vertex *neighbor(int rotation);
    Vertex *advance(int rotation);
    Vertex *setV(Vertex*);
    Vertex *insert(Point2D&);
    void remove();
    Polygon *split(Vertex*);
};

#endif // _POLYGON_H_
