/*
 * PrimitiveTypes.h
 *
 * Copyright (C) 1994-96, Christoph Streit <streit@iam.unibe.ch>
 *                        Stephan Amann <amann@iam.unibe.ch>
 *                        University of Berne, Switzerland
 *
 * All rights reserved.
 *
 * This software may be freely copied, modified, and redistributed
 * provided that this copyright notice is preserved on all copies.
 *
 * You may not distribute this software, in whole or in part, as part of
 * any commercial product without the express consent of the authors.
 *
 * There is no warranty or other guarantee of fitness of this software
 * for any purpose.  It is provided solely "as is".
 *
 * -----------------------------------------------------------------------------
 *  $Id: PrimitiveTypes.h,v 1.6 1996/08/07 09:21:14 amann Exp $
 * -----------------------------------------------------------------------------
 */

#ifndef _PrimitiveTypes_H
#define _PrimitiveTypes_H

#include <values.h> // MAXFLOAT, MAXDOUBLES, ...

//_______________________________________________________________________ Switch
// Whenever a switch is needed
//
enum Switch { ON, OFF };

//_________________________________________________________________________ Real
// Choose the appropriate Real representation.
//

typedef double Real;
const Real MAXREAL =  MAXDOUBLE;
const Real MINREAL = -MAXDOUBLE;

// typedef float Real;
// const Real MAXREAL =  MAXFLOAT;
// const Real MINREAL = -MAXFLOAT;

const Real EPSILON = 0.00001;

//_________________________________________________________________________ bool

#ifndef __GNUC__
typedef int bool;

const bool true  = 1;
const bool false = 0;
#endif

#endif // _PrimitiveTypes_H
