#ifndef _REPORTING_H_
#define _REPORTING_H_


#include <fstream.h>
#include <time.h>

#define FILENAME "memdebug.txt"



void initDebugInformation() {

  ofstream deb(FILENAME);
  deb << "Debugging Report for Memory Leaks in Image classes" << endl;
  deb << "--------------------------------------------------" << endl;
  deb << endl;
  deb << "Timestamp;Class;Method;Type;Pointer" << endl;
  deb << endl;
  deb.close();  

};



void writeDebugInformation(char *tmpClass, char *tmpMethod, char *tmpType, int tmpPointer) {

  ofstream deb;
  deb.open(FILENAME, ios::app);

  // create timestamp
  time_t seconds;
  seconds = time(&seconds);
  tm* currentTime;
  currentTime = localtime(&seconds);
  
  deb << currentTime->tm_mday << "." << (currentTime->tm_mon + 1) << "." << currentTime->tm_year << " ";
  deb << currentTime->tm_hour << ":" << currentTime->tm_min << "." << currentTime->tm_sec << ";";
  deb << tmpClass << ";" << tmpMethod << ";" << tmpType << ";" << tmpPointer << endl;
  deb.close();

};



#endif // _REPORTING_H_
