#include "SpannedAreaOfPoints.h"
#include "DelaunayTriangulation.h"
#include <math.h>


#include <iostream.h>


SpannedAreaOfPoints::SpannedAreaOfPoints() { };

SpannedAreaOfPoints::~SpannedAreaOfPoints() { };

double SpannedAreaOfPoints::apply(Point2D s[], int n) {

  // Algorithm:  1) Calculate Delaunay Triangulation
  //             2) Sum area of every Triangle

  // Triangulation
  DelaunayTriangulation myTriangulation;
  List<Polygon*> *myTriangles = myTriangulation.apply(s, n);

  // Calculate Area of all Triangles together
  if (myTriangles->length() == 0) {
    cout << "No triangles found" << endl;
    return 0.0;
  };
  cout << myTriangles->length() << " triangles found ";
  double area = 0.0;
  Polygon *aTriangle = NULL;
  Vertex *aVertex = NULL;
  for (myTriangles->first(); !myTriangles->isHead(); myTriangles->next()) {
    aTriangle = myTriangles->val();
    Point2D a = aTriangle->point();
    aVertex = aTriangle->advance(1);
    Point2D b = aTriangle->point();
    aVertex = aTriangle->advance(1);
    Point2D c = aTriangle->point();
    Point2D u = b - a;
    Point2D v = c - a;
    area += (0.5 * fabs(u.x*v.y - u.y*v.x));
  };
  cout << "with total area " << area << endl;
  return area;
};







