#ifndef _STACK_H_
#define _STACK_H_

#include "List.h"



template<class T> class Stack {
  private:
    List<T> *s;
  public:
    Stack();
    ~Stack();
    void push(T v);
    T pop();
    bool empty();
    int size();
    T top();
    T nextToTop();
    T bottom();
};

template<class T> Stack<T>::Stack() : s(new List<T>) { };

template<class T> Stack<T>::~Stack() {
  delete s;
};

template<class T> void Stack<T>::push(T v) {
  a->prepend(v);
};

template<class T> T Stack<T>::pop() {
  s->first();
  return a->remove();
};

template<class T> bool Stack<T>::empty() {
  return (s->length() == 0);
};

template<class T> int Stack<T>::size() {
  return s->length();
};

template<class T> T Stack::top() {
  return s->first();
};

template<class T> T Stack::nextToTop() {
  s->first();
  return s->next();
};

template<class T> T Stack::bottom() {
  return s->last();
};




#endif // _STACK_H_
