#ifndef _TREENODE_H_
#define _TREENODE_H_

#include <stdlib.h>


template<class T> class SearchTree;


template<class T> class TreeNode {
  protected:
    TreeNode *_lchild;
    TreeNode *_rchild;
    T val;
  public:
    TreeNode(T);
    virtual ~TreeNode(void);
    friend class SearchTree<T>;
    friend class BraidedSearchTree<T>;
};

template<class T> TreeNode<T>::TreeNode(T v) : _lchild(NULL), _rchild(NULL), val(v) { };

template<class T> TreeNode<T>::~TreeNode() {
  if (_lchild) delete _lchild;
  if (_rchild) delete _rchild;
};


#endif // _TREENODE_H_
