#include "Vertex.h"


Vertex::Vertex(double x, double y) : Point2D (x,y) { };

Vertex::Vertex(Point2D &p) : Point2D(p) { };

Vertex *Vertex::cw() {
  return (Vertex*)_next;
};

Vertex *Vertex::ccw() {
  return (Vertex*)_prev;
};

Vertex *Vertex::neighbor(int rotation) {
  return ((rotation == CLOCKWISE) ? cw() : ccw());
};

Point2D Vertex::point() {
  return *((Point2D*)this);
};

Vertex *Vertex::insert(Vertex *v) {
  return (Vertex *)(Node::insert(v));
};

Vertex *Vertex::remove() {
  return (Vertex *)(Node::remove());
};

void Vertex::splice(Vertex *b) {
  Node::splice(b);
};

Vertex *Vertex::split(Vertex *b) {
  // insert bp before Vertex b
  Vertex *bp = b->ccw()->insert(new Vertex(b->point()));
  // insert ap after this Vertex
  insert(new Vertex(Point2D())); 
  splice(bp);
  return bp;
};
