#ifndef _VERTEX_H_
#define _VERTEX_H_

#include "Point2D.h"
#include "Node.h"
class Polygon;

class Vertex : public Node, public Point2D {
  public:
    enum { CLOCKWISE, COUNTERCLOCKWISE };
    Vertex(double x, double y);
    Vertex(Point2D&);
    Vertex *cw();
    Vertex *ccw();
    Vertex *neighbor(int rotation);
    Point2D point();
    Vertex *insert(Vertex*);
    Vertex *remove();
    void splice(Vertex*);
    Vertex *split(Vertex*);
    friend class Polygon;
};


#endif // _VERTEX_H_
