#!/usr/local/bin/perl

# collects all .ethz files in the passed directories and subdirs
# and appends them to one single file passed as first argument
#
# usage   collect.pl target_file.ethz dir0 dir2 dir3 ...



# parse command line
if ($#ARGV < 1) {
    print "\n";
    print "Usage: collect.pl targetfile directory [dir] [dir] ...\n";
    print "\n";
    exit();
};
$targetfile = $ARGV[0];
@directories = ();
for ($i = 1; $i <= $#ARGV; $i++) {
    push @directories, $ARGV[$i];
};
print "Targetfile:  $targetfile\n";
print "Directories: $directories[0]\n";
for ($i = 1; $i <= $#directories; $i++) {
    print "             $directories[$i]\n";
};



# check targetfile for existing words
if (open(TARGET, $targetfile)) {
    $oldwords = <TARGET>;
    if ($oldwords =~ /^\s*(\d+)\s*$/) {
      $oldwords = $1;
    } else { 
      $oldwords = 0;
    };
} else {
    $oldwords = 0;
};
if ($oldwords >= 1) {
  print "$targetfile.old contains already $oldwords words\n";
} else {
  print "$targetfile.old contains no words\n";
};
close TARGET;
system "mv $targetfile $targetfile.old";



# search for files 'points.ethz' in every dir and append them to TARGET
open(TARGET, ">$targetfile.new");
$newwords = 0;
foreach $dir (@directories) {

  open (DIRS, "find $dir -name points.ethz -print |");
  while ($file = <DIRS>) {
    print "$file";

    # check ob wirklich Punkte enthalten sind
    open (FILE, $file);
    @lines = <FILE>;
    if (($lines[$#lines] eq "]\n") && ($lines[$#lines-1] eq "[\n")) {
      close FILE;
      @lines = ();
      print "contains no points\n\n";
      next; # jump to next iteration of while loop
    };
    @lines = ();
    close FILE;

    # einlesen
    open (FILE, $file);
    $line = <FILE>;
    if ($line =~ /^\s*(\d+)\s*$/) {
      $newwords += $1;
      print "$1 new word(s)\n"; 
    } else {
      $newwords++;
      print "single new word\n";  
      print TARGET $line;      
    };
    while ($line = <FILE>) {
      print TARGET $line; 
    };
    close FILE;

  };
  close DIRS;

};
close TARGET;
print "$targetfile.new contains $newwords new words\n";



# merging new and old file
open (TARGET, ">$targetfile");
open (SOURCE, "$targetfile.old");
$line = <SOURCE>;
print TARGET $newwords+$oldwords;
print TARGET "\n";
if ($line =~ /^\s*(\d+)\s*$/) {
  # ignore first line containing old number of words
} else {
  print TARGET $line;      
};
while ($line = <SOURCE>) {
  print TARGET $line; 
};
close SOURCE;
open (SOURCE, "$targetfile.new");
while ($line = <SOURCE>) {
  print TARGET $line; 
};
close SOURCE;
close TARGET;



# done
system "rm -f $targetfile.new";
system "rm -f $targetfile.old";
print "$targetfile contains ";
print $newwords+$oldwords;
print " words\n\n";

















