#!/usr/local/bin/perl

# merges several ETHZ Online-Data files into a new single file
#
# usage   merge.pl target source1 [src2 src2 ...]



# parse command line
if ($#ARGV < 1) {
    print "\n";
    print "Usage: merge.pl targetfile source1 [src2 src2 src3 ...]\n";
    print "\n";
    exit();
};
$targetfile = $ARGV[0];
@sourcefiles = ();
for ($i = 1; $i <= $#ARGV; $i++) {
    push @sourcefiles, $ARGV[$i];
};
print "\nTargetfile:  $targetfile\n\n";



# open every sourcefile and add the word to the TARGET
open(TARGET, ">$targetfile.new");
$words = 0;
foreach $src (@sourcefiles) {

  open (SOURCE, $src);
  @lines = <SOURCE>;
  if (($lines[$#lines] eq "]\n") && ($lines[$#lines-1] eq "[\n")) {
    close SOURCE;
    @lines = ();
    print "contains no points\n\n";
    next; # jump to next iteration of while loop
  };
  @lines = ();
  close SOURCE;

  # einlesen
  open (SOURCE, $src);
  $line = <SOURCE>;
  print "$src contains ";
  if ($line =~ /^\s*(\d+)\s*$/) {
    $words += $1;
    print "$1 new word(s)\n"; 
  } else {
    $words++;
    print "single new word\n";  
    print TARGET $line;      
  };
  while ($line = <SOURCE>) {
    print TARGET $line; 
  };
  close SOURCE;

};
close TARGET;


# printing number of words in front of $targetfile
open (TARGET, ">$targetfile");
open (SOURCE, "$targetfile.new");
print TARGET "$words\n";
while ($line = <SOURCE>) {
  print TARGET $line; 
};
close SOURCE;
close TARGET;
system "rm -f $targetfile.new";
print "\n$targetfile contains $words words.\n\n";


# done
















