#!/usr/local/bin/perl

$mpegtools = "/home/siebenth/diplom/mpeg2codec";
$tempdir = "/tmp";

# check argument
if ($# != 0) {
  print "Usage:  mpeg2ppm.pl path/mpegfile\n\n";
  exit;
};
if (stat $ARGV[0] == ()) {
  print "file $ARGV[0] doesn't exist\n\n";
  exit;
};

# extract $filename from full path and extension
@fileparts = split(/\//, $ARGV[0]);
($filename, $extension) = split(/\./, $fileparts[$#fileparts]);


# generate directory $filename
print "creating directory $filename ...\n";
system "mkdir $filename";


# decode MPEG stream to directory
print "extracting MPEG file to sequence of PPM files ...\n";
system "$mpegtools/mpeg2decode -o3 $ARGV[0] $filename/test%04d";


# convert Truecolor ppm to Greyscale ppm images
print "converting TrueColor to Greyscale PPM's ...\n";
open (PPM, "cd $filename; ls test*.ppm|");
while ($oldfile = <PPM>) {

  $oldfile =~ s/\n$//g;
  $newfile = "$tempdir/$oldfile";
  $newfile =~ s/\.ppm$/\.pgm/g;
  $cmdline1 = "ppmtopgm $filename/$oldfile > $newfile";
  $cmdline2 = "mv $newfile $filename/$oldfile";

  print "$cmdline1\n$cmdline2\n";
  system $cmdline1;
  system $cmdline2;

};
close PPM;

print "\nfile $filename completed.\n\n";
