/* otsu.f -- translated by f2c (version 19950110).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ 
void otsu(const long double *rhst, integer *ngr, integer *jthd, doublereal *rmean, doublereal *vari, doublereal *p0, doublereal *p1, doublereal *a0, doublereal *a1, doublereal *sep)
{
    /* Initialized data */

    static doublereal eps = (float)1e-10;

    /* System generated locals */
    integer i__1;

    /* Local variables */
    static doublereal amax;
    static integer ithd;
    static doublereal pmax, smax, a, d;
    static integer i;
    static doublereal p, s, va, rh, ri, rm;
    static integer ngr1;

/*                                                                      00
000200*/
/*    Copyright (c) 1983 by AIST MITI(JAPAN)                            00
000300*/
/*                                                                      00
000400*/
/*S    CALL THDS2(RHST,NGR,JTHD,RMEAN,VARI,P0,P1,A0,A1,SEP)              0
0000500*/
/*                                                                      00
000600*/
/*P     Threshold selection for binarization by the Otsu's discriminate  0
0000700*/
/*P     analysis method.                                                 0
0000800*/
/*                                                                      00
000900*/
/*K       THRESHOLD SELECTION, BINARIZATION, DISCRIMINANT ANALYSIS       0
0001000*/
/*                                                                      00
001100*/
/*A     RHST(NGR): Gray-level histogram                               (I)0
0001200*/
/*A     NGR      : Number of gray levels                              (I)0
0001300*/
/*A     JTHD     : Threshold value selected                           (O)0
0001400*/
/*A     RMEAN    : Global mean value                                  (O)0
0001500*/
/*A     VARI     : Global variance                                    (O)0
0001600*/
/*A     P0,P1    : Probability of occurrence in each class            (O)0
0001700*/
/*A     A0,A1    : Mean value of each class                           (O)0
0001800*/
/*A     SEP      : Class separability                                 (O)0
0001900*/
/*                                                                      00
002000*/
/*N      References                                                      0
0002100*/
/*N [1]  N. Otsu, "A threshold selection method from gray-level          0
0002200*/
/*N      histogram," IEEE Trans., vol. SMC-9, pp. 62-66, Jan. 1979.      0
0002300*/
/*N [2]  N. Otsu, "An automatic threshold selection method based on      0
0002400*/
/*N      discriminant and least squares criteria," IECE Trans., vol.     0
0002500*/
/*N      J63-D, pp. 349-356, April 1980 (in Japanese).                   0
0002600*/
/*                                                                      00
002700*/
/*N           NOTE:  INPUT HISTOGRAM MUST BE NORMALIZED SO THAT          0
0002800*/
/*N                 ITS TOTAL AMOUNT IS 1.0.                             0
0002900*/
/*N                                                                      0
0003000*/
/*                                                                      00
003100*/
/*D          FEB  20, 1979, PROGRAMMED BY M.TEZUKA                       0
0003200*/
/*D          JUNE  3, 1980, MODIFIED   BY H.TAMURA                       0
0003300*/
/*D          JULY  7, 1980, REFORMED   BY E.UENO                         0
0003400*/
/*                                                                      00
003500*/
/*                                                                      00
003600*/
/*                                                                      00
003700*/
    /* Parameter adjustments */
    --rhst;

    /* Function Body */
/*                                                                      00
004000*/
/*                                                                      00
004100*/
    ithd = 0;
    ngr1 = *ngr - 1;
/*                                                                      00
004400*/
/*F ** COMPUTATION OF GLOBAL MEAN AND VARIANCE                           0
0004500*/
    rm = (float)0.;
    va = (float)0.;
    i__1 = *ngr;
    for (i = 1; i <= i__1; ++i) {
	ri = (doublereal) (i - 1);
	rh = ri * rhst[i];
	rm += rh;
	va += ri * rh;
/* L10: */
    }
    *rmean = rm;
    *vari = va - rm * rm;
/*                                                                      00
005600*/
/*F ** DETERMINATION OF OPTIMAL THRESHOLD VALUE                          0
0005700*/
    smax = (float)0.;
    p = (float)0.;
    a = (float)0.;
    i__1 = ngr1;
    for (i = 1; i <= i__1; ++i) {
	rh = rhst[i];
	p += rh;
	a += (doublereal) (i - 1) * rh;
	s = rm * p - a;
	d = p * ((float)1. - p);
	if (d < eps) {
	    goto L20;
	}
	s = s * s / d;
	if (s < smax) {
	    goto L20;
	}
	smax = s;
	amax = a;
	pmax = p;
	ithd = i;
L20:
	;
    }
/*                                                                      00
007500*/
/*F ** RETURN WITH SEVERAL OUTPUT PARAMETER VALUES                       0
0007600*/
    *jthd = ithd - 1;
    *p0 = pmax;
    *p1 = (float)1. - *p0;
    *a0 = amax / pmax;
    *a1 = (rm - amax) / *p1;
    *sep = smax / *vari;
/*                                                                      00
008300*/
/*                                                                      00
008400*/
    return;
} /* thds2_ */

