#include "image/ImageSourcePPM.C"
#include <iostream.h>
#include "image/FilterStrategy.h"
#include <list.h>
#include "image/FilterRotate180.h"
#include "image/FilterCutRectangle.h"
#include "image/PPMWriter.h"
#include "image/Histogram.h"
#include "image/Filter.h"
#include "image/DetectorNeighbour.h"



void main() {

  ImageSourcePPM aSource;
  aSource.setParameters("/home/siebenth/diplom/mpeg/bc1/", "test", 4, ".ppm");


  list<FilterStrategy*> myPreprocessing;
  FilterRotate180 myFilterRotate180;
  FilterCutRectangle myFilterCutRectangle(Rectangle(10,10,200,200));
  myPreprocessing.push_back(&myFilterRotate180);
  myPreprocessing.push_back(&myFilterCutRectangle);

  PPMWriter aWriter("./dummy.ppm");

  Image* myDeltaMergeWait[5];
  for(int k = 0; k < 5; k++) {
    myDeltaMergeWait[k] = new Image8(200-10+1, 200-10+1);
    (myDeltaMergeWait[k])->setWhite();
  };


  Image *result = NULL;

  for (int i = aSource.getFirstIndex(); i < aSource.getLastIndex(); i++) {

    result = aSource.getImageAbsolute(i);

    list<FilterStrategy*>::iterator I = myPreprocessing.begin();
    Image* newImage;
    while (I != myPreprocessing.end()) {
      newImage = (*I)->apply(result);
      delete result;
      result = newImage;
      I++;
    };

    Histogram aHisto(result);
    Image *aHistImg = aHisto.createImage();
    delete aHistImg;

    Filter aFilter;
    Image *tmpImage = (myDeltaMergeWait[5-1])->copy();
    aFilter.applyMergeImages(result, tmpImage, Rectangle(0,0,200-10,200-10));
    delete myDeltaMergeWait[0];
    for(int l = 0; l < 5-1; l++) {
      myDeltaMergeWait[l] = myDeltaMergeWait[l+1];
    };
    myDeltaMergeWait[5-1] = tmpImage;
    
    
    Image* delta = aFilter.applyDeltaImage(result, result, Rectangle(0,0,200,200));
    aFilter.applyDeltaImageCorrection(delta, result, result, Rectangle(0,0,200,200), 0);
    delete delta;

    /*
    DetectorNeighbour aDetector(Rectangle(0,0,200,200),128);
    Point pos = aDetector.apply(result, Rectangle(90,90,110,110));
    cout << pos << endl;
    */

    char c;
    if ((i % 10) == 0) {
      cout << "any key for next 10 images ...";
      cin >> c;
    };

    aWriter.apply(result);
    delete result;

  };


};





