#include "SpannedAreaOfPoints.h"
#include <iostream.h>
#include <math.h>
#include <stdlib.h>



// Hilfsfunktionen
void swap(Point2D a[], int i, int j) {
  Point2D t = a[i];
  a[i] = a[j];
  a[j] = t;
};
double theta(Point2D p1, Point2D p2) {
  int dx, dy, ax, ay;
  double t;
  dx = (int) (p2.x - p1.x); ax = abs((int)dx);
  dy = (int) (p2.y - p1.y); ay = abs((int)dy);
  t = (ax+ay == 0) ? 0 : (double) dy/(ax+ay);
  if (dx < 0) t = 2-t; else if (dy < 0) t = 4+t;
  return t*90.0;
};


// Einwickeln einer Punktmenge
int wrap(Point2D p[], int N) {
  int i, min, M;
  double th, v;
  for (min = 0, i = 0; i < N; i++)
    if (p[i].y < p[min].y) min = i;
  p[0] = p[min]; th = 0.0;
  for (M = 0; M < N; M++) {
    swap(p, M, min);
    min = N; v = th; th = 360.0;
    for (i = M+1; i <= N; i++)
      if (theta(p[M], p[i]) > v)
        if (theta(p[M], p[i]) < th) {
          min = i;
          th = theta(p[M], p[min]);
        };
    if (min == N) return M;
  };
};


void main() {

  SpannedAreaOfPoints myArea;

  Point2D p[10+1];
  p[0] = Point2D(0.0,0.0);
  p[1] = Point2D(8.0,2.0);
  p[2] = Point2D(4.0,4.0);
  p[3] = Point2D(2.0,1.0);
  p[4] = Point2D(2.0,3.0);
  p[5] = Point2D(13.0,6.0);
  p[6] = Point2D(1.0,7.0);
  p[7] = Point2D(10.0,5.0);
  p[8] = Point2D(9.0,10.0);
  p[9] = Point2D(4.0,10.0);

  double area = myArea.apply(p, 10);

  cout << "Phippu's Algorithmus: ";

  /*
  Point2D s[7];
  s[0] = Point2D(0.0,0.0);
  s[1] = Point2D(1.0,7.0);
  s[2] = Point2D(4.0,10.0);
  s[3] = Point2D(9.0,10.0);
  s[4] = Point2D(13.0,6.0);
  s[5] = Point2D(8.0,2.0);
  s[6] = Point2D(0.0,0.0);
  */

  int m = wrap(p, 10);

  cout << "Convex Hull with " << m+1 << " points: ";
  for (int i = 0; i <= m; i++) {
    cout << "(" << p[i].x << "/" << p[i].y << ") ";
  };
  p[m] = p[0];
  double a = 0.0;
  for (int i = 0; i <= m; i++) {
    a += ((p[i+1].y - p[i].y)*(p[i+1].x + p[i].x));
  };
  a /= 2.0;
  cout << "-> " << a << endl;

};






















